'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};/* eslint max-len:off */exports.default=ArrowBox;var _react=require('react');var _react2=_interopRequireDefault(_react);var _propTypes=require('prop-types');var _propTypes2=_interopRequireDefault(_propTypes);var _classnames=require('classnames');var _classnames2=_interopRequireDefault(_classnames);var _Icon=require('./Icon');var _Colors=require('./Colors');var _Colors2=_interopRequireDefault(_Colors);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}var getValue=function getValue(str){return str.match(/^[0-9]*/g)[0];};var getUnit=function getUnit(str){return str.match(/[^0-9].*/g)[0];};var capitalize=function capitalize(str){return str.charAt(0).toUpperCase()+str.slice(1);};var hasUnit=function hasUnit(str){var bool=false;if(typeof str!=='undefined'&&str!==null&&getValue(str).length>0){bool=true;}return bool;};var halfUnit=function halfUnit(str){return getValue(str)/2+getUnit(str);};function ArrowBox(props){// Use manualPositioning first.
// If no manualPositioning, but height/width has a defined unit value
// in css, then use half of that. Or else just use 0px.
var posHeight=props.manualPositioning;var posWidth=props.manualPositioning;if(!posHeight){if(hasUnit(props.height)){posHeight=halfUnit(props.height);}else{posHeight='0px';}}if(!posWidth){if(hasUnit(props.width)){posWidth=halfUnit(props.width);}else{posWidth='0px';}}var directions={top:{bottom:'calc(100% + 1rem)',left:'calc('+props.relativeOffset+' - '+posWidth+')'},right:{left:'calc(100% + 1rem)',top:'calc('+props.relativeOffset+' - '+posHeight+')'},bottom:{top:'calc(100% + 1rem)',left:'calc('+props.relativeOffset+' - '+posWidth+')'},left:{right:'calc(100% + 1rem)',top:'calc('+props.relativeOffset+' - '+posHeight+')'},none:{}};var borderStyle={};if(props.direction!=='none'){borderStyle['border'+capitalize(props.direction)+'Color']=props.color;}return _react2.default.createElement('div',{className:(0,_classnames2.default)('arrow-box',{'arrow-box_top':props.direction==='top'},{'arrow-box_right':props.direction==='right'},{'arrow-box_bottom':props.direction==='bottom'},{'arrow-box_left':props.direction==='left'},{'arrow-box_no-arrow':props.direction==='none'},{'arrow-box_hidden':!props.show},props.className),style:_extends(directions[props.direction],{width:props.width},{height:props.height},{backgroundColor:props.color},props.style)},// eslint-disable-next-line react/prop-types
props.children,_react2.default.createElement('span',{className:'arrow-box--arrow',style:_extends(borderStyle,props.arrowStyle)}),props.icon?_react2.default.createElement(_Icon.Icon,{className:'arrow-box--icon',type:props.icon,size:'regular',fill:props.color}):null);}ArrowBox.propTypes={direction:_propTypes2.default.oneOf(['top','right','bottom','left','none']),show:_propTypes2.default.bool,icon:_propTypes2.default.oneOf([].concat(_Icon.IconTypes,null)),color:_propTypes2.default.string,width:_propTypes2.default.string,height:_propTypes2.default.string,// Offset from element that arrow box is relative to.
// Ex. if relativeOffset = '50%', then the arrow box is
// 50% of the main element's width or height
relativeOffset:_propTypes2.default.string,// css values in string form
manualPositioning:_propTypes2.default.string,// css values in string form
// style and arrowStyle are inline css style objects
style:_propTypes2.default.object,// eslint-disable-line
arrowStyle:_propTypes2.default.object,// eslint-disable-line
className:_propTypes2.default.string};ArrowBox.defaultProps={direction:'top',show:false,width:'15rem',height:'auto',relativeOffset:'50%',manualPositioning:null,icon:null,color:_Colors2.default.gray_50,className:''};module.exports=exports['default'];
//# sourceMappingURL=ArrowBox.js.map
